import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] mass = new long[n];
        long k = 0;
        long summ = 0;
        for (int i = 0; i < n; i++) {
            mass[i] = nextLong();
            summ += mass[i];
        }
        int q = nextInt();
        for (int i = 0; i < q; i ++) {
            int l = nextInt();
            if (l==1) {
                int y = nextInt()-1;
                int h = (int)((k+y+n)%n);
                summ -= mass[h];
                mass[h] = nextLong();
                summ+=mass[h];
            } else {
                k -= nextLong();
                k%=n;
            }
            out.println(summ);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}