import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int t = nextInt();
        int[] mass = new int[n*n];
        int[] mass1 = new int[n*n];
        double[] mass2 = new double[n*n];
        for (int i = 0; i < n; i ++) {
            int k = nextInt();
            for (int j = 0; j < n; j ++) {
                mass[i*n+j] = k;
                mass2[i*n+j] = k;
            }
        }
        for (int i = 0; i < n; i ++) {
            int k = nextInt();
            for (int j = 0; j < n; j ++) {
                mass1[j*n+i] = k;
                mass2[j*n+i] /= k;
            }
        }
        for (int i = 0; i < n*n; i ++) {
            for (int j = 0; j < n*n-i-1; j ++) {
                if (mass2[j] > mass2[j+1]) {
                    mass2[j] += mass2[j+1];
                    mass2[j+1] = mass2[j] - mass2[j+1];
                    mass2[j] -= mass2[j+1];
                    mass1[j] += mass1[j+1];
                    mass1[j+1] = mass1[j] - mass1[j+1];
                    mass1[j] -= mass1[j+1];
                    mass[j] += mass[j+1];
                    mass[j+1] = mass[j] - mass[j+1];
                    mass[j] -= mass[j+1];
                }
            }
        }
        for (int i = 0; i < t; i ++) {
            long h = nextLong()-1;
            long a = mass[(int)h];
            long b = mass1[(int)h];
            while (b!= 0) {
                a%=b;
                b+=a;
                a = b-a;
                b-=a;
            }
            out.println(mass[(int)h]/a + " " +(mass1[(int)h]/a));
        }
        out.close();
    }
    static long func (int i) {
        long otv = 1;
        for (int j = 1; j <= i; j ++) {
            otv = (otv*j)%1000000007L;
        } return otv;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}